#!/bin/sh

#create .jwmrc-drives to reflect drives/partitions present
# get PDEV1 and PUP_HOME from PUPSTATE
. /etc/rc.d/PUPSTATE

echo "<JWM>
<Tray layout=\"horizontal\" x=\"-25\" y=\"-50\" height=\"52\" layer=\"0\" border=\"1\">
" > /root/.jwmrc-drives

# for each partition found
for PART in $(fdisk -l | grep "/dev/" | grep -v "Disk" | cut -d " " -f 1); do

	# set the default icon, for standard drives
	ICON='drive'

	# get filesystem type
	TYPE="$(guess_fstype "${PART}" 2>/dev/null)"

	# if not swap or unknown partition
	if [ ! "${TYPE}" = "unknown"  -a ! "${TYPE}" = "swap" ]; then
		# set mount path
		MNTPATH="$(echo $PART | sed 's/\/dev\///g')"
		# check for usb drives
		USBCHK=''
		USBCHK=$(probedisk2 | grep "usbdrv" | grep "${MNTPATH:0:3}" )
		# if USB partition, change icon
		[ "$USBCHK" != "" ] && ICON='usbdrv'
		# set label
		LABEL="$(blkid-name-generator $MNTPATH)"
		# if mnt path found is PDEV1, replace with PUP_HOME or /mnt/home, works with automount
		if [ "$MNTPATH" = "$PDEV1" ];then # if current partition contains the pup_*.sfs file
			# set icon as unmountable partition
			ICON="${ICON}_mntd_boot"
			if [ $PUPMODE = 12 -o $PUPMODE = 13 ];then # if save file is in use
				# save file is being used, use /mnt/home
				MNTPATH="$(readlink /mnt/home)"
				# add the partition to the jwm tray
				echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec: rox -n $MNTPATH</TrayButton>" >> /root/.jwmrc-drives
			else # no save file being used
				MNTPATH=`mount | grep '/initrd/mnt/dev_ro' | cut -f 3 -d ' '` # get the mounted ro loop in initrd (bad hack, I think!)
				if [ "$MNTPATH" = "" ];then # if mnt path above is not found
					# usr default mount path (required for some newer pups.. later than 4.2)
					MNTPATH="$(echo $PART | sed 's/\/dev\///g')" # set mount point as normal, if nothing was found at /initrd/mnt/dev_ro*/ 
					# add to jwm tray
					echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec:drive_mounter.sh ${MNTPATH}</TrayButton>" >> /root/.jwmrc-drives
				else # unmountable mount point already.. just open with rox
					# add to jwm tray
					echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec: rox -n ${MNTPATH}</TrayButton>" >> /root/.jwmrc-drives
				fi
			fi
		else # not the pup_*.sfs partition, open normal mount point
			# check if $PART is already mounted
			mount | grep "$MNTPATH" > /dev/null 2>&1 #mount command returns 0 if string found... meaning drive is mounted
			if [ $? = 0 ]; then # if drive already mounted
				ICON="${ICON}_mntd"
			fi
			echo "<TrayButton popup=\"${LABEL}, ${TYPE}\" icon=\"${ICON}48.png\">exec:drive_mounter.sh ${MNTPATH}</TrayButton>" >> /root/.jwmrc-drives
		fi
	fi
done

echo "<TrayButton popup=\"sr0\" icon=\"optical48.png\">exec:/usr/sbin/cd_mounter.sh</TrayButton>
<TrayButton popup=\"fd0\" icon=\"floppy48.png\">exec:/usr/sbin/floppy_mounter.sh</TrayButton>
</Tray>
</JWM>" >> /root/.jwmrc-drives